/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
 * 
 */
package jp.mosp.kintai.common.part;

import jp.mosp.common.common.MospException;
import jp.mosp.common.part.PartInfo;
import jp.mosp.common.part.PartStore;

/**
 * MosP勤怠管理のPartを保持するクラス
 * @author yoshida
 *	@version 0.0.5
 */
public class KintaiPartStore extends PartStore {
	
	/**
	 * コンストラクタ
	 */
	public KintaiPartStore() {
		super();
	}
	
	/**
	 * コンストラクタ
	 * @param partInfo Partを利用する際に必要な情報
	 */
	private KintaiPartStore(PartInfo partInfo) {
		this();
		setPartInfo(partInfo);
	}
	
	/**
	 * KintaiPartStoreインスタンス生成
	 * @param partInfo		Partを利用する際に必要な情報
	 * @return	KintaiPartStoreインスタンス
	 */
	public static KintaiPartStore getInstance(PartInfo partInfo) {
		return new KintaiPartStore(partInfo);
	}
	
	/**
	 * CalculatePartインスタンス取得
	 * @return	初期化済みCalculatePartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public CalculatePart calculate() throws MospException {
		return (CalculatePart)get(CalculatePart.class);
	}
	
	/**
	 * HumanPartインスタンス取得
	 * @return	初期化済みHumanPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public HumanPart human() throws MospException {
		return (HumanPart)get(HumanPart.class);
	}
	
	/**
	 * SectionPartインスタンス取得
	 * @return	初期化済みSectionPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public SectionPart section() throws MospException {
		return (SectionPart)get(SectionPart.class);
	}
	
	/**
	 * OfficePartインスタンス取得
	 * @return	初期化済みOfficePartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public OfficePart office() throws MospException {
		return (OfficePart)get(OfficePart.class);
	}
	
	/**
	 * WorkTypePartインスタンス取得
	 * @return	初期化済みWorkTypePartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public WorkTypePart worktype() throws MospException {
		return (WorkTypePart)get(WorkTypePart.class);
	}
	
	/**
	 * PositionPartインスタンス取得
	 * @return	初期化済みPositionPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public PositionPart position() throws MospException {
		return (PositionPart)get(PositionPart.class);
	}
	
	/**
	 * RotationPartインスタンス取得
	 * @return	初期化済みRotationPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public RotationPart rotation() throws MospException {
		return (RotationPart)get(RotationPart.class);
	}
	
	/**
	 * KintaiApprovalPartインスタンス取得
	 * @return	初期化済みKintaiApprovalPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public KintaiApprovalPart kintaiApproval() throws MospException {
		return (KintaiApprovalPart)get(KintaiApprovalPart.class);
	}
	
	/**
	 * ApprovalPartインスタンス取得
	 * @return	初期化済みApprovalPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public ApprovalPart approval() throws MospException {
		return (ApprovalPart)get(ApprovalPart.class);
	}
	
	/**
	 * KintaiCommonPartインスタンス取得
	 * @return	初期化済みKintaiCommonPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public KintaiCommonPart kintai() throws MospException {
		return (KintaiCommonPart)get(KintaiCommonPart.class);
	}
	
	/**
	 * KintaiCompilePartインスタンス取得
	 * @return	初期化済みKintaiCompilePartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public KintaiCompilePart compile() throws MospException {
		return (KintaiCompilePart)get(KintaiCompilePart.class);
	}
	
	/**
	 * OverTimePartインスタンス取得
	 * @return	初期化済みOverTimePartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public OverTimePart overtime() throws MospException {
		return (OverTimePart)get(OverTimePart.class);
	}
	
	/**
	 * ExportPartインスタンス取得
	 * @return	初期化済みExportPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public ExportPart export() throws MospException {
		return (ExportPart)get(ExportPart.class);
	}
	
	/**
	 * HolidayRequestPartインスタンス取得
	 * @since	0.0.2
	 * @return	初期化済みHolidayRequestPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public HolidayRequestPart holidayRequest() throws MospException {
		return (HolidayRequestPart)get(HolidayRequestPart.class);
	}
	
	/**
	 * PaidHolidayPartインスタンス取得
	 * @since	0.0.3
	 * @return	初期化済みPaidHolidayPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public PaidHolidayPart paidHoliday() throws MospException {
		return (PaidHolidayPart)get(PaidHolidayPart.class);
	}
	
	/**
	 * WorkflowPartインスタンス取得
	 * @return 初期化済みWorkflowPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public WorkflowPart workflow() throws MospException {
		return (WorkflowPart)get(WorkflowPart.class);
	}
	
	/**
	 * LaborAgreementPartインスタンス取得
	 * @since 0.0.5
	 * @return 初期化済みLaborAgreementPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public LaborAgreementPart laborAgreement() throws MospException {
		return (LaborAgreementPart)get(LaborAgreementPart.class);
	}
	
	/**
	 * SubstituteHolidayPartインスタンス取得
	 * @since 0.0.6
	 * @return 初期化済みSubstituteHolidayPartインスタンス
	 * @throws MospException MosP例外処理が発生した場合
	 */
	public SubstituteHolidayPart subHoliday() throws MospException {
		return (SubstituteHolidayPart)get(SubstituteHolidayPart.class);
	}
	
}
